#ifndef __DOMAIN_ATTRIBUT__
#define __DOMAIN_ATTRIBUT__

using namespace blitz ;

namespace XMLIOSERVER
{
   class DomainAttribut : public virtual AttributRegistrar
   {
      public :

         DECLARE_ATTR(name          , string) ;
         DECLARE_ATTR(standard_name , string) ;
         DECLARE_ATTR(long_name     , string) ;

         DECLARE_ATTR(ni_glo        , int) ;
         DECLARE_ATTR(nj_glo        , int) ;

         DECLARE_ATTR(ibegin        , int) ;
         DECLARE_ATTR(iend          , int) ;
         DECLARE_ATTR(ni            , int) ;

         DECLARE_ATTR(jbegin        , int) ;
         DECLARE_ATTR(jend          , int) ;
         DECLARE_ATTR(nj            , int) ;

         DECLARE_ATTR(mask          , Array(bool, 2)) ;

         DECLARE_ATTR(data_dim      , int) ;
         DECLARE_ATTR(data_ni       , int) ;
         DECLARE_ATTR(data_nj       , int) ;
         DECLARE_ATTR(data_ibegin   , int) ;
         DECLARE_ATTR(data_jbegin   , int) ;

         DECLARE_ATTR(data_n_index  , int) ;
         DECLARE_ATTR(data_i_index  , Array(int, 1)) ;
         DECLARE_ATTR(data_j_index  , Array(int, 1)) ;

         DECLARE_ATTR(lonvalue      , Array(double, 1)) ;
         DECLARE_ATTR(latvalue      , Array(double, 1)) ;
         DECLARE_ATTR(domtype       , string);

         DomainAttribut(void) : AttributRegistrar()
         { this->registerAllAttributes(); }

      private :

         void registerAllAttributes(void)
         {
            RegisterAttribut(&name) ;
            RegisterAttribut(&standard_name) ;
            RegisterAttribut(&long_name) ;
            RegisterAttribut(&ni_glo);
            RegisterAttribut(&nj_glo) ;
            RegisterAttribut(&ibegin) ;
            RegisterAttribut(&iend) ;
            RegisterAttribut(&ni) ;
            RegisterAttribut(&jbegin) ;
            RegisterAttribut(&jend) ;
            RegisterAttribut(&nj) ;
            RegisterAttribut(&mask) ;

            RegisterAttribut(&data_dim) ;
            RegisterAttribut(&data_ni);
            RegisterAttribut(&data_nj) ;
            RegisterAttribut(&data_ibegin) ;
            RegisterAttribut(&data_jbegin) ;
            RegisterAttribut(&data_n_index) ;
            RegisterAttribut(&data_i_index) ;
            RegisterAttribut(&data_j_index) ;

            RegisterAttribut(&lonvalue) ;
            RegisterAttribut(&latvalue) ;
            RegisterAttribut(&domtype) ;
         }

   } ; // class DomainAttribut

}// namespace XMLIOSERVER

#endif //__DOMAIN_ATTRIBUT__
